package be.jeffcheasey88.peeratcode.parser.java;

import be.jeffcheasey88.peeratcode.parser.Token;

public class Value extends JavaElement{

	private Token token;
	
	private Value value;
	
	protected Value(){}
	
	public Value(Token token){
		this.token = token;
	}
	
	public void switchInto(Value value){
		this.value = value;
	}
	
	public Value get(){
		return this.value;
	}
	
	@Override
	public String toString(){
		return "[Value="+token+", val="+((value == null ? "null":value.getClass().getSimpleName()))+"]";
	}
	
	public static class BiValue extends Value{
		
		private Value left;
		private Value right;
		
		private Token type; //make a concat later
		
		public BiValue(Value left, Value right, Token operation){
			this.left = left.get() == null ? left : left.get();
			this.right = right.get() == null ? right : right.get();
			
			this.type = operation;
		}
		
		@Override
		public String toString(){
			return "[BiValue left="+left+" type="+type+" right="+right+"]";
		}
	}
	
	public static class TriValue extends Value{
		
		private Value condition;
		
		private Value success;
		private Value fail;
		
		public TriValue(Value condition, Value success, Value fail){
			this.condition = condition;
			this.success = success;
			this.fail = fail;
		}
		
		public void setCondition(Value value){
			this.condition = value;
		}
		
		public Value getCondition(){
			return this.condition;
		}
		
		public Value success(){
			return this.success;
		}
		
		public Value fail(){
			return this.fail;
		}
		
		@Override
		public String toString(){
			return "[TriValue "+condition+" ? "+success+" : "+fail+"]";
		}
	}
}
